﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DadaLib
{
    /// <summary>
    /// Interface for any sentence generator
    /// </summary>
    public interface IGenerator
    {

        void Analize();

        /// <summary>
        /// Analizes a text file.
        /// </summary>
        void Analize(string fileName);
        
        /// <summary>
        /// Gets the next word.
        /// </summary>
        /// <param name="seedWord">The seed word.</param>
        /// <returns></returns>
        string GetNextWord(string seedWord);

        /// <summary>
        /// Searches a word suitable for starting a sentence.
        /// </summary>
        /// <returns></returns>
        string SearchStartWord();
    }
}
